%{!?upstream_version: %global upstream_version %{version}%{?milestone}}
%global service neutron

%define cleanup_orphan_rootwrap_daemons() \
for pid in $(ps -f --ppid 1 | awk '/.*neutron-rootwrap-daemon/ { print $2 }'); do \
   kill $(ps --ppid $pid -o pid=) \
done \
%nil

%global common_desc \
Neutron is a virtual network service for Openstack. Just like \
OpenStack Nova provides an API to dynamically request and configure \
virtual servers, Neutron provides an API to dynamically request and \
configure virtual networks. These networks connect "interfaces" from \
other OpenStack services (e.g., virtual NICs from Nova VMs). The \
Neutron API supports extensions to provide advanced network \
capabilities (e.g., QoS, ACLs, network monitoring, etc.)

Name:           openstack-%{service}
Version:        12.1.1
Release:        42%{?dist}
Epoch:          1
Summary:        OpenStack Networking Service

License:        ASL 2.0
URL:            http://launchpad.net/%{service}/

Source0:        https://tarballs.openstack.org/%{service}/%{service}-%{upstream_version}.tar.gz
Source1:        %{service}.logrotate
Source2:        %{service}-sudoers
Source10:       neutron-server.service
Source11:       neutron-linuxbridge-agent.service
Source12:       neutron-openvswitch-agent.service
Source15:       neutron-dhcp-agent.service
Source16:       neutron-l3-agent.service
Source17:       neutron-metadata-agent.service
Source18:       neutron-ovs-cleanup.service
Source19:       neutron-macvtap-agent.service
Source20:       neutron-metering-agent.service
Source21:       neutron-sriov-nic-agent.service
Source22:       neutron-netns-cleanup.service
Source29:       neutron-rpc-server.service

Source30:       %{service}-dist.conf
Source31:       conf.README
Source32:       neutron-linuxbridge-cleanup.service
Source33:       neutron-enable-bridge-firewall.sh
Source34:       neutron-l2-agent-sysctl.conf
# We use the legacy service to load modules because it allows to gracefully
# ignore a missing kernel module (f.e. br_netfilter on earlier kernels). It's
# essentially because .modules files are shell scripts.
Source35:       neutron-l2-agent.modules
Source36:       neutron-destroy-patch-ports.service

# patches_ignore=DROP-IN-RPM
# patches_base=12.1.1
Patch0001: 0001-Create-executable-for-removing-patch-ports.patch
Patch0002: 0002-Destroy-patch-ports-only-if-canary-flow-is-not-prese.patch
Patch0003: 0003-Change-VF-status-from-enable-to-auto.patch
Patch0004: 0004-Delay-floating-IP-assignation-in-DVR-router-during-m.patch
Patch0005: 0005-Fix-mismatch-of-tags-in-dnsmasq-options.patch
Patch0006: 0006-Increase-timeout-when-waiting-for-dnsmasq-enablement.patch
Patch0007: 0007-Run-revision-bump-operations-en-masse.patch
Patch0008: 0008-Add-more-condition-to-check-sg-member-exist.patch
Patch0009: 0009-Force-network_id-in-subnet-DB-registers.patch
Patch0010: 0010-Increase-timeout-when-waiting-for-dnsmasq-enablement.patch
Patch0011: 0011-don-t-clear-skb-mark-when-ovs-is-hw-offload-enabled.patch
Patch0012: 0012-L3-Switch-order-of-processing-added-and-removed-rout.patch
Patch0013: 0013-Change-provider-network-segmentation-ID.patch
Patch0014: 0014-Decouple-local-VLAN-internal-management-and-OVS-enfo.patch
Patch0015: 0015-Allow-provider-net-attr-in-update-if-no-change.patch
Patch0016: 0016-Change-provider-network-segmentation-ID-in-OVS-agent.patch
Patch0017: 0017-Log-OVS-firewall-conjunction-creation.patch
Patch0018: 0018-Handle-OVSFWPortNotFound-and-OVSFWTagNotFound-in-ovs.patch
Patch0019: 0019-Switch-to-use-cast-method-in-dhcp_ready_on_ports-met.patch
Patch0020: 0020-OVS-FW-Clean-port-rules-if-port-not-found-in-ovsdb.patch
Patch0021: 0021-Set-DB-retry-for-quota_enforcement-pecan_wsgi-hook.patch
Patch0022: 0022-Do-not-unbind-a-port-during-pre-live-migration.patch
Patch0023: 0023-Add-retries-to-update-trunk-port.patch
Patch0024: 0024-List-SG-rules-which-belongs-to-tenant-s-SG.patch
Patch0025: 0025-Fix-listing-of-security-group-rules-by-regular-user.patch
Patch0026: 0026-Ensure-driver-error-preventing-trunk-port-deletion-i.patch
Patch0027: 0027-Mock-check-if-ipv6-is-enabled-in-L3-agent-unit-tests.patch
Patch0028: 0028-Change-process-name-of-neutron-server-to-match-worke.patch
Patch0029: 0029-Re-use-existing-ProcessLauncher-from-wsgi-in-RPC-wor.patch
Patch0030: 0030-Use-threading-for-pinging-the-floating-IP.patch
Patch0031: 0031-During-post-live-migration-do-not-disable-destinatio.patch
Patch0032: 0032-Prioritize-port-create-and-update-ready-messages.patch
Patch0033: 0033-Revert-Switch-to-use-cast-method-in-dhcp_ready_on_po.patch
Patch0034: 0034-Add-bulk-IP-address-assignment-to-ipam-driver.patch
Patch0035: 0035-DVR-Ignore-DHCP-port-during-DVR-host-query.patch
Patch0036: 0036-Optimize-DVR-related-port-DB-query.patch
Patch0037: 0037-Remove-sleep-command-when-retrieving-OVS-dp.patch
Patch0038: 0038-DVR-Don-t-populate-unbound-ports-in-router-s-ARP-cac.patch
Patch0039: 0039-Do-not-initialize-snat-ns-twice.patch
Patch0040: 0040-Add-trunk-subports-to-be-one-of-dvr-serviced-device-.patch
Patch0041: 0041-Wait-before-deleting-trunk-bridges-for-DPDK-vhu.patch
Patch0042: 0042-Support-iproute2-4.15-in-l3_tc_lib.patch
Patch0043: 0043-Fix-is_port_bound-function-in-l3_dvr_db-module.patch
Patch0044: 0044-Switch-ip-addr-add-del-flush-commands-to-use-pyroute.patch
Patch0045: 0045-Switch-create-delete-interfaces-to-pyroute2.patch
Patch0046: 0046-Allow-to-kill-keepalived-state-change-monitor-proces.patch
Patch0047: 0047-Define-orm-relationships-after-db-classes.patch
Patch0048: 0048-OVS-Handle-added-removed-ports-in-the-same-polling-i.patch
Patch0049: 0049-Always-set-ovs-bridge-name-in-vif-binding-details.patch
Patch0050: 0050-dhcp-agent-equalize-port-create_low-update-delete-pr.patch
Patch0051: 0051-Check-SG-members-instead-of-ports-to-skip-flow-updat.patch
Patch0052: 0052-Ensure-that-fullstack-job-is-run-with-python-2.7.patch
Patch0053: 0053-ovs-agent-signal-to-plugin-if-tunnel-refresh-needed.patch
Patch0054: 0054-Improve-OVSFirewallDriver.process_trusted_ports.patch
Patch0055: 0055-Remove-extra-header-fields-in-proxied-metadata-reque.patch
Patch0056: 0056-Ensure-that-default-SG-exists-during-list-of-SG-rule.patch
Patch0057: 0057-Add-VLAN-type-conntrack-direct-flow.patch
Patch0058: 0058-Add-accepted-egress-direct-flow.patch
Patch0059: 0059-Remove-Floating-IP-DNS-record-upon-associated-port-d.patch
Patch0060: 0060-Increase-waiting-time-for-network-rescheduling.patch
Patch0061: 0061-Handle-ports-assigned-to-routers-without-routerports.patch
Patch0062: 0062-Check-dnsmasq-process-is-active-when-spawned.patch
Patch0063: 0063-Filter-by-owner-SGs-when-retrieving-the-SG-rules.patch
Patch0064: 0064-Refactor-the-L3-agent-batch-notifier.patch
Patch0065: 0065-Change-ovs-agent-iteration-log-level-to-INFO.patch
Patch0066: 0066-Don-t-raise-error-when-removing-not-existing-IP-addr.patch
Patch0067: 0067-Delay-HA-router-transition-from-backup-to-master.patch
Patch0068: 0068-List-SG-rules-which-belongs-to-tenant-s-SG.patch
Patch0069: 0069-Fix-listing-of-security-group-rules-by-regular-user.patch
Patch0070: 0070-Dynamically-increase-l3-router-process-queue-green-p.patch
Patch0071: 0071-Unnecessary-routers-should-not-be-created.patch
Patch0072: 0072-Do-not-link-up-HA-router-gateway-in-backup-node.patch
Patch0073: 0073-Ensure-that-stale-flows-are-cleaned-from-phys_bridge.patch
Patch0074: 0074-DVR-Reconfigure-re-created-physical-bridges-for-dvr-.patch
Patch0075: 0075-Kill-parent-process-of-ip-monitor-command.patch
Patch0076: 0076-Allow-usage-of-legacy-3rd-party-interface-drivers.patch
Patch0077: 0077-Adding-LOG-statements-to-debug-1838449.patch
Patch0078: 0078-Router-synch-shouldn-t-return-unrelated-routers.patch
Patch0079: 0079-Make-QoS-OVS-agent-deletion-operations-more-resilian.patch
Patch0080: 0080-Do-not-block-connection-between-br-int-and-br-phys-o.patch
Patch0081: 0081-Avoid-empty-vsctl-transactions.patch
Patch0082: 0082-Catch-OVSFWTagNotFound-in-update_port_filter.patch
Patch0083: 0083-Improve-log-message-when-port-losts-its-vlan-tag.patch
Patch0084: 0084-Add-config-option-http_retries.patch
Patch0085: 0085-DVR-Related-routers-should-be-included-if-are-reques.patch
Patch0086: 0086-Ensure-drop-flows-on-br-int-at-agent-startup-for-DVR.patch
Patch0087: 0087-Set-process-name-for-agents.patch
Patch0088: 0088-OVS-FW-Remote-SG-IDs-left-behind-when-a-SG-is-remove.patch
Patch0089: 0089-Don-t-check-if-any-bridges-were-recrected-when-OVS-w.patch
Patch0090: 0090-Improve-VLAN-allocations-synchronization.patch
Patch0091: 0091-Report-L3-extensions-enabled-in-the-L3-agent-s-confi.patch
Patch0092: 0092-Only-notify-nova-of-port-status-changes-if-configure.patch
Patch0093: 0093-Fix-queens-gates-multiple-fixes.patch
Patch0094: 0094-Add-igmp_snooping_enable-config-option-for-OVS-agent.patch
Patch0095: 0095-OVS-Make-QoS-OVS-agent-deletion-operations-more-resi.patch
Patch0096: 0096-EM-releases-Move-non-voting-jobs-to-the-experimental.patch
Patch0097: 0097-Update-the-processing-of-assigned-addresses-when-ass.patch
Patch0098: 0098-Make-_ensure_default_security_group-method-atomic.patch
Patch0099: 0099-Don-t-add-arp-responder-for-non-tunnel-network-port.patch
Patch0100: 0100-stable-only-Configure-logging-in-keepalived_state_ch.patch
Patch0101: 0101-Ensure-drop-flows-on-br-int-at-agent-startup-for-DVR.patch
Patch0102: 0102-Fix-validation-of-IPv6-subnets-with-external-RAs.patch
Patch0103: 0103-Fix-Traceback-when-running-neutron-ipset-cleanup-too.patch
Patch0104: 0104-Security-fix-allowed-address-pair-0.0.0.0-0-issue.patch
Patch0105: 0105-Add-vrrp_garp_master_delay-and-vrrp_garp_master_repe.patch
Patch0106: 0106-Do-not-send-a-GARP-when-a-new-floating-IP-is-added.patch
Patch0107: 0107-Fix-get_ports-db-plugin-method.patch
Patch0108: 0108-Fix-test_keepalived_configuration-functional-test.patch
Patch0109: 0109-Not-remove-the-running-router-when-MQ-is-unreachable.patch
Patch0110: 0110-Use-dict-.get-to-avoid-a-KeyError-in-the-segment-plu.patch
Patch0111: 0111-Fix-unnecessary-security_groups_member_updated-notif.patch
Patch0112: 0112-Fix-deletion-of-subnet_id-from-pd_subnets.patch
Patch0113: 0113-Pass-context-in-disassociate_floatingip-notification.patch
Patch0114: 0114-Pass-context-in-l3-flavor-notifications.patch
Patch0115: 0115-Do-not-fail-deleting-namespace-if-it-does-not-exist.patch
Patch0116: 0116-neutron-server-api-worker-process-should-be-named-to.patch
Patch0117: 0117-Fix-calling-of-add_tunnel_port-method-from-sanity-ch.patch
Patch0118: 0118-GRE-Add-possibility-to-create-GRE-tunnels-over-IPv6.patch
Patch0119: 0119-OvS-Handle-re_added-multi-ports.patch
Patch0120: 0120-Ensure-fip-ip-rules-deleted-when-fip-removed.patch
Patch0121: 0121-Import-oslo_config.cfg-before-eventlet.patch
Patch0122: 0122-windows-fix-terminating-processes.patch
Patch0123: 0123-ovs-firewall-fix-mac-learning-on-the-ingress-rule-ta.patch
Patch0124: 0124-ping-ping6-command-support-in-rootwrap-filters.patch
Patch0125: 0125-Support-gateway-which-is-not-in-subnet-CIDR-in-ha_ro.patch
Patch0126: 0126-Don-t-raise-FileNotFoundError-during-disabling-keepa.patch
Patch0127: 0127-Load-the-glibc-library-only-once-for-Pyroute2.patch
Patch0128: 0128-Replace-ctype.CDLL-by-ctypes.PyDLL-in-linux.ip_lib.patch
Patch0129: 0129-Drop-invalid-rootwrap-filters.patch
Patch0130: 0130-Local-mac-direct-flow-for-non-openflow-firewall.patch
Patch0131: 0131-Revert-Security-fix-allowed-address-pair-0.0.0.0-0-i.patch
Patch0132: 0132-Fix-migration-from-the-HA-to-non-HA-routers.patch
Patch0133: 0133-Fix-update-of-trunk-subports-during-live-migration.patch
Patch0134: 0134-Don-t-try-to-create-default-SG-when-security-groups-.patch
Patch0135: 0135-OVS-FW-Clean-conntrack-entries-with-mark-CT_MARK_INV.patch
Patch0136: 0136-Fix-wrong-packet_type-set-for-IPv6-GRE-tunnels-in-OV.patch

BuildArch:      noarch

BuildRequires:  git
BuildRequires:  openstack-macros
BuildRequires:  python2-devel
BuildRequires:  python2-babel
BuildRequires:  python-d2to1
BuildRequires:  python2-keystoneauth1 >= 3.3.0
BuildRequires:  python2-keystonemiddleware
BuildRequires:  python2-neutron-lib
BuildRequires:  python2-novaclient
BuildRequires:  python2-os-xenapi
BuildRequires:  python2-oslo-cache
BuildRequires:  python2-oslo-concurrency
BuildRequires:  python2-oslo-config
BuildRequires:  python2-oslo-db
BuildRequires:  python2-oslo-log
BuildRequires:  python2-oslo-messaging
BuildRequires:  python2-oslo-policy
BuildRequires:  python2-oslo-privsep
BuildRequires:  python2-oslo-rootwrap
BuildRequires:  python2-oslo-service
BuildRequires:  python2-oslo-versionedobjects
BuildRequires:  python2-osprofiler >= 1.3.0
BuildRequires:  python2-ovsdbapp
BuildRequires:  python2-pbr >= 2.0.0
BuildRequires:  python2-psutil >= 3.2.2
BuildRequires:  python2-pyroute2 >= 0.4.21
BuildRequires:  python2-pecan
BuildRequires:  python2-tenacity >= 3.2.1
BuildRequires:  python2-weakrefmethod >= 1.0.2
BuildRequires:  systemd

Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}

# dnsmasq is not a hard requirement, but is currently the only option
# when neutron-dhcp-agent is deployed.
Requires:       dnsmasq >= 2.76
Requires:       dnsmasq-utils >= 2.76

# radvd is not a hard requirement, but is currently the only option
# for IPv6 deployments.
Requires:       radvd

# dibbler is not a hard requirement, but is currently the default option
# for IPv6 prefix delegation.
Requires:       dibbler-client

# conntrack is not a hard requirement, but is currently used by L3 agent
# to immediately drop connections after a floating IP is disassociated
Requires:       conntrack-tools

# keepalived is not a hard requirement, but is currently used by DVR L3
# agent
Requires:       keepalived

# haproxy implements metadata proxy process
Requires:       haproxy >= 1.5.0

# Those are not hard requirements, ipset is used by ipset-cleanup in the subpackage,
# and iptables is used by the l3-agent which currently is not in a separate package.
Requires:       ipset
Requires:       iptables

%{?systemd_requires}

Obsoletes:      openstack-%{service}-dev-server

%description
%{common_desc}


%package -n python-%{service}
Summary:        Neutron Python libraries
Requires:       python2-alembic >= 0.8.10
Requires:       python2-debtcollector >= 1.2.0
Requires:       python2-designateclient >= 2.7.0
Requires:       python2-eventlet >= 0.18.2
Requires:       python2-greenlet >= 0.4.10
Requires:       python-httplib2 >= 0.9.1
Requires:       python2-jinja2 >= 2.8
Requires:       python2-keystoneauth1 >= 3.3.0
Requires:       python2-keystonemiddleware >= 4.17.0
Requires:       python2-netaddr >= 0.7.18
Requires:       python-netifaces >= 0.10.4
Requires:       python2-neutronclient >= 6.3.0
Requires:       python2-neutron-lib >= 1.13.0
Requires:       python2-novaclient >= 9.1.0
Requires:       python2-os-xenapi >= 0.3.1
Requires:       python2-oslo-cache >= 1.26.0
Requires:       python2-oslo-concurrency >= 3.25.0
Requires:       python2-oslo-config >= 2:5.1.0
Requires:       python2-oslo-context >= 2.19.2
Requires:       python2-oslo-db >= 4.27.0
Requires:       python2-oslo-i18n >= 3.15.3
Requires:       python2-oslo-log >= 3.36.0
Requires:       python2-oslo-messaging >= 5.29.0
Requires:       python2-oslo-middleware >= 3.31.0
Requires:       python2-oslo-policy >= 1.30.0
Requires:       python2-oslo-privsep >= 1.23.0
Requires:       python2-oslo-reports >= 1.18.0
Requires:       python2-oslo-rootwrap >= 5.8.0
Requires:       python2-oslo-serialization >= 2.18.0
Requires:       python2-oslo-service >= 1.24.0
Requires:       python2-oslo-utils >= 3.33.0
Requires:       python2-oslo-versionedobjects >= 1.31.2
Requires:       python2-osprofiler >= 1.4.0
Requires:       python2-ovsdbapp
Requires:       python-paste
Requires:       python-paste-deploy >= 1.5.0
Requires:       python2-pecan >= 1.0.0
Requires:       python2-pbr >= 2.0.0
Requires:       python2-psutil >= 3.2.2
Requires:       python2-pyroute2 >= 0.4.21
Requires:       python2-requests >= 2.14.2
Requires:       python2-tenacity >= 3.2.1
Requires:       python2-routes >= 2.3.1
Requires:       python2-ryu >= 4.14
Requires:       python2-six >= 1.10.0
Requires:       python2-sqlalchemy >= 1.0.10
Requires:       python2-stevedore >= 1.20.0
Requires:       python2-weakrefmethod >= 1.0.2
Requires:       python-webob >= 1.7.1



%description -n python-%{service}
%{common_desc}

This package contains the Neutron Python library.


%package -n python-%{service}-tests
Summary:        Neutron tests
Requires:       python-%{service} = %{epoch}:%{version}-%{release}
Requires:       python2-ddt >= 1.0.1
Requires:       python2-fixtures >= 3.0.0
Requires:       python2-mock >= 2.0
Requires:       python2-subunit >= 0.0.18
Requires:       python2-testrepository >= 0.0.18
Requires:       python2-testtools >= 1.4.0
Requires:       python2-testresources >= 0.2.4
Requires:       python2-testscenarios >= 0.4
Requires:       python2-oslotest >= 1.10.0
Requires:       python2-os-testr >= 0.7.0
Requires:       python2-PyMySQL >= 0.6.2
Requires:       python2-tempest >= 12.1.0
Requires:       python-webtest >= 2.0

# pstree is used during functional testing to ensure our internal
# libraries managing processes work correctly.
Requires:       psmisc
# nfs-utils is needed because it creates user with uid 65534 which
# is required by neutron functional tests.
Requires:       nfs-utils


%description -n python-%{service}-tests
%{common_desc}

This package contains Neutron test files.


%package common
Summary:        Neutron common files
Requires(pre): shadow-utils
Requires:       python-%{service} = %{epoch}:%{version}-%{release}
Requires:       sudo


%description common
%{common_desc}

This package contains Neutron common files.


%package linuxbridge
Summary:        Neutron Linuxbridge agent
Requires:       bridge-utils
Requires:       ebtables
Requires:       ipset
Requires:       iptables
# kmod is needed to get access to /usr/sbin/modprobe needed by
# neutron-enable-bridge-firewall.sh triggered by the service unit file
Requires:       kmod
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description linuxbridge
%{common_desc}

This package contains the Neutron agent that implements virtual
networks using VLAN or VXLAN using Linuxbridge technology.


%package macvtap-agent
Summary:        Neutron macvtap agent
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description macvtap-agent
%{common_desc}

This package contains the Neutron agent that implements
macvtap attachments for libvirt qemu/kvm instances.


%package ml2
Summary:        Neutron ML2 plugin
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}
# needed for brocade and cisco drivers
Requires:       python2-ncclient


%description ml2
%{common_desc}

This package contains a Neutron plugin that allows the use of drivers
to support separately extensible sets of network types and the mechanisms
for accessing those types.


%package openvswitch
Summary:        Neutron openvswitch plugin
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}
# We require openvswitch when using vsctl to access ovsdb;
# but if we use native access, then we just need python bindings.
# since we don't know what users actually use, we depend on both.
Requires:       ipset
Requires:       iptables
Requires:       openvswitch
Requires:       python-openvswitch >= 2.8.0
# kmod is needed to get access to /usr/sbin/modprobe needed by
# neutron-enable-bridge-firewall.sh triggered by the service unit file
Requires:       kmod


%description openvswitch
%{common_desc}

This package contains the Neutron plugin that implements virtual
networks using Open vSwitch.


%package metering-agent
Summary:        Neutron bandwidth metering agent
Requires:       iptables
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description metering-agent
%{common_desc}

This package contains the Neutron agent responsible for generating bandwidth
utilization notifications.


%package rpc-server
Summary:        Neutron (RPC only) Server
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description rpc-server
%{common_desc}

This package contains an alternative Neutron server that handles AMQP RPC
workload only.


%package sriov-nic-agent
Summary:        Neutron SR-IOV NIC agent
Requires:       openstack-%{service}-common = %{epoch}:%{version}-%{release}


%description sriov-nic-agent
%{common_desc}

This package contains the Neutron agent to support advanced features of
SR-IOV network cards.


%prep
%autosetup -n %{service}-%{upstream_version} -S git

find %{service} -name \*.py -exec sed -i '/\/usr\/bin\/env python/{d;q}' {} +

# Let's handle dependencies ourseleves
%py_req_cleanup

# Kill egg-info in order to generate new SOURCES.txt
rm -rf neutron.egg-info


%build
export SKIP_PIP_INSTALL=1
%{__python2} setup.py build
# Generate i18n files
# (amoralej) we can remove '-D neutron' once https://review.openstack.org/#/c/485070/ is merged
%{__python2} setup.py compile_catalog -d build/lib/%{service}/locale -D neutron

# Generate configuration files
PYTHONPATH=. tools/generate_config_file_samples.sh
find etc -name *.sample | while read filename
do
    filedir=$(dirname $filename)
    file=$(basename $filename .sample)
    mv ${filename} ${filedir}/${file}
done

# Loop through values in neutron-dist.conf and make sure that the values
# are substituted into the neutron.conf as comments. Some of these values
# will have been uncommented as a way of upstream setting defaults outside
# of the code. For notification_driver, there are commented examples
# above uncommented settings, so this specifically skips those comments
# and instead comments out the actual settings and substitutes the
# correct default values.
while read name eq value; do
  test "$name" && test "$value" || continue
  if [ "$name" = "notification_driver" ]; then
    sed -ri "0,/^$name *=/{s!^$name *=.*!# $name = $value!}" etc/%{service}.conf
  else
    sed -ri "0,/^(#)? *$name *=/{s!^(#)? *$name *=.*!# $name = $value!}" etc/%{service}.conf
  fi
done < %{SOURCE30}

%install
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}

# Remove unused files
rm -rf %{buildroot}%{python2_sitelib}/bin
rm -rf %{buildroot}%{python2_sitelib}/doc
rm -rf %{buildroot}%{python2_sitelib}/tools

# Move rootwrap files to proper location
install -d -m 755 %{buildroot}%{_datarootdir}/%{service}/rootwrap
mv %{buildroot}/usr/etc/%{service}/rootwrap.d/*.filters %{buildroot}%{_datarootdir}/%{service}/rootwrap

# Move config files to proper location
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}
mv %{buildroot}/usr/etc/%{service}/* %{buildroot}%{_sysconfdir}/%{service}
mv %{buildroot}%{_sysconfdir}/%{service}/api-paste.ini %{buildroot}%{_datadir}/%{service}/api-paste.ini

# The generated config files are not moved automatically by setup.py
install -d -m 755 %{buildroot}%{_sysconfdir}/%{service}/plugins/ml2

mv etc/%{service}.conf %{buildroot}%{_sysconfdir}/%{service}/%{service}.conf
for agent in dhcp l3 metadata metering
do
  mv etc/${agent}_agent.ini %{buildroot}%{_sysconfdir}/%{service}/${agent}_agent.ini
done
for file in linuxbridge_agent ml2_conf openvswitch_agent sriov_agent
do
  mv etc/%{service}/plugins/ml2/${file}.ini %{buildroot}%{_sysconfdir}/%{service}/plugins/ml2/${file}.ini
done

# Install logrotate
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-%{service}

# Install sudoers
install -p -D -m 440 %{SOURCE2} %{buildroot}%{_sysconfdir}/sudoers.d/%{service}

# Install systemd units
install -p -D -m 644 %{SOURCE10} %{buildroot}%{_unitdir}/neutron-server.service
install -p -D -m 644 %{SOURCE11} %{buildroot}%{_unitdir}/neutron-linuxbridge-agent.service
install -p -D -m 644 %{SOURCE12} %{buildroot}%{_unitdir}/neutron-openvswitch-agent.service
install -p -D -m 644 %{SOURCE15} %{buildroot}%{_unitdir}/neutron-dhcp-agent.service
install -p -D -m 644 %{SOURCE16} %{buildroot}%{_unitdir}/neutron-l3-agent.service
install -p -D -m 644 %{SOURCE17} %{buildroot}%{_unitdir}/neutron-metadata-agent.service
install -p -D -m 644 %{SOURCE18} %{buildroot}%{_unitdir}/neutron-ovs-cleanup.service
install -p -D -m 644 %{SOURCE19} %{buildroot}%{_unitdir}/neutron-macvtap-agent.service
install -p -D -m 644 %{SOURCE20} %{buildroot}%{_unitdir}/neutron-metering-agent.service
install -p -D -m 644 %{SOURCE21} %{buildroot}%{_unitdir}/neutron-sriov-nic-agent.service
install -p -D -m 644 %{SOURCE22} %{buildroot}%{_unitdir}/neutron-netns-cleanup.service
install -p -D -m 644 %{SOURCE29} %{buildroot}%{_unitdir}/neutron-rpc-server.service
install -p -D -m 644 %{SOURCE32} %{buildroot}%{_unitdir}/neutron-linuxbridge-cleanup.service
install -p -D -m 644 %{SOURCE36} %{buildroot}%{_unitdir}/neutron-destroy-patch-ports.service

# Install helper scripts
install -p -D -m 755 %{SOURCE33} %{buildroot}%{_bindir}/neutron-enable-bridge-firewall.sh

# Install sysctl and modprobe config files to enable bridge firewalling
# NOTE(ihrachys) we effectively duplicate same settings for each affected l2
# agent. This can be revisited later.
install -p -D -m 644 %{SOURCE34} %{buildroot}%{_sysctldir}/99-neutron-openvswitch-agent.conf
install -p -D -m 644 %{SOURCE34} %{buildroot}%{_sysctldir}/99-neutron-linuxbridge-agent.conf
install -p -D -m 755 %{SOURCE35} %{buildroot}%{_sysconfdir}/sysconfig/modules/neutron-openvswitch-agent.modules
install -p -D -m 755 %{SOURCE35} %{buildroot}%{_sysconfdir}/sysconfig/modules/neutron-linuxbridge-agent.modules

# Install README file that describes how to configure services with custom configuration files
install -p -D -m 755 %{SOURCE31} %{buildroot}%{_sysconfdir}/%{service}/conf.d/README

# Setup directories
install -d -m 755 %{buildroot}%{_datadir}/%{service}
install -d -m 755 %{buildroot}%{_sharedstatedir}/%{service}
install -d -m 755 %{buildroot}%{_localstatedir}/log/%{service}
install -d -m 755 %{buildroot}%{_localstatedir}/run/%{service}

# Install dist conf
install -p -D -m 640 %{SOURCE30} %{buildroot}%{_datadir}/%{service}/%{service}-dist.conf

# Create and populate configuration directory for L3 agent that is not accessible for user modification
mkdir -p %{buildroot}%{_datadir}/%{service}/l3_agent
ln -s %{_sysconfdir}/%{service}/l3_agent.ini %{buildroot}%{_datadir}/%{service}/l3_agent/l3_agent.conf

# Create dist configuration directory for neutron-server (may be filled by advanced services)
mkdir -p %{buildroot}%{_datadir}/%{service}/server

# Create configuration directories for all services that can be populated by users with custom *.conf files
mkdir -p %{buildroot}/%{_sysconfdir}/%{service}/conf.d/common
for service in server rpc-server ovs-cleanup netns-cleanup linuxbridge-cleanup macvtap-agent; do
    mkdir -p %{buildroot}/%{_sysconfdir}/%{service}/conf.d/%{service}-$service
done
for service in linuxbridge openvswitch dhcp l3 metadata metering sriov-nic; do
    mkdir -p %{buildroot}/%{_sysconfdir}/%{service}/conf.d/%{service}-$service-agent
done

# Install i18n .mo files (.po and .pot are not required)
install -d -m 755 %{buildroot}%{_datadir}
rm -f %{buildroot}%{python2_sitelib}/%{service}/locale/*/LC_*/%{service}*po
rm -f %{buildroot}%{python2_sitelib}/%{service}/locale/*pot
mv %{buildroot}%{python2_sitelib}/%{service}/locale %{buildroot}%{_datadir}/locale

# Find language files
%find_lang %{service} --all-name

%pre common
getent group %{service} >/dev/null || groupadd -r %{service}
getent passwd %{service} >/dev/null || \
    useradd -r -g %{service} -d %{_sharedstatedir}/%{service} -s /sbin/nologin \
    -c "OpenStack Neutron Daemons" %{service}
exit 0


%post
%systemd_post neutron-dhcp-agent.service
%systemd_post neutron-l3-agent.service
%systemd_post neutron-metadata-agent.service
%systemd_post neutron-server.service
%systemd_post neutron-netns-cleanup.service
%systemd_post neutron-ovs-cleanup.service
%systemd_post neutron-linuxbridge-cleanup.service


%preun
%systemd_preun neutron-dhcp-agent.service
%systemd_preun neutron-l3-agent.service
%systemd_preun neutron-metadata-agent.service
%systemd_preun neutron-server.service
%systemd_preun neutron-netns-cleanup.service
%systemd_preun neutron-ovs-cleanup.service
%systemd_preun neutron-linuxbridge-cleanup.service


%postun
%systemd_postun_with_restart neutron-dhcp-agent.service
%systemd_postun_with_restart neutron-l3-agent.service
%systemd_postun_with_restart neutron-metadata-agent.service
%systemd_postun_with_restart neutron-server.service
%cleanup_orphan_rootwrap_daemons


%post macvtap-agent
%systemd_post neutron-macvtap-agent.service


%preun macvtap-agent
%systemd_preun neutron-macvtap-agent.service


%postun macvtap-agent
%systemd_postun_with_restart neutron-macvtap-agent.service
%cleanup_orphan_rootwrap_daemons


%post linuxbridge
%systemd_post neutron-linuxbridge-agent.service


%preun linuxbridge
%systemd_preun neutron-linuxbridge-agent.service


%postun linuxbridge
%systemd_postun_with_restart neutron-linuxbridge-agent.service
%cleanup_orphan_rootwrap_daemons

%post openvswitch
%systemd_post neutron-openvswitch-agent.service
%systemd_post neutron-destroy-patch-ports.service

if [ $1 -ge 2 ]; then
    # We're upgrading

    # Detect if the neutron-openvswitch-agent is running
    ovs_agent_running=0
    systemctl status neutron-openvswitch-agent > /dev/null 2>&1 && ovs_agent_running=1 || :

    # If agent is running, stop it
    [ $ovs_agent_running -eq 1 ] && systemctl stop neutron-openvswitch-agent > /dev/null 2>&1 || :

    # Search all orphaned neutron-rootwrap-daemon processes and since all are triggered by sudo,
    # get the actual rootwrap-daemon process.
    %cleanup_orphan_rootwrap_daemons

    # If agent was running, start it back with new code
    [ $ovs_agent_running -eq 1 ] && systemctl start neutron-openvswitch-agent > /dev/null 2>&1 || :
fi


%preun openvswitch
%systemd_preun neutron-openvswitch-agent.service
%systemd_preun neutron-destroy-patch-ports.service


%post metering-agent
%systemd_post neutron-metering-agent.service


%preun metering-agent
%systemd_preun neutron-metering-agent.service


%postun metering-agent
%systemd_postun_with_restart neutron-metering-agent.service
%cleanup_orphan_rootwrap_daemons


%post sriov-nic-agent
%systemd_post neutron-sriov-nic-agent.service


%preun sriov-nic-agent
%systemd_preun neutron-sriov-nic-agent.service


%postun sriov-nic-agent
%systemd_postun_with_restart neutron-sriov-nic-agent.service
%cleanup_orphan_rootwrap_daemons


%files
%license LICENSE
%{_bindir}/neutron-api
%{_bindir}/neutron-db-manage
%{_bindir}/neutron-debug
%{_bindir}/neutron-dhcp-agent
%{_bindir}/neutron-ipset-cleanup
%{_bindir}/neutron-keepalived-state-change
%{_bindir}/neutron-l3-agent
%{_bindir}/neutron-linuxbridge-cleanup
%{_bindir}/neutron-metadata-agent
%{_bindir}/neutron-netns-cleanup
%{_bindir}/neutron-ovs-cleanup
%{_bindir}/neutron-pd-notify
%{_bindir}/neutron-sanity-check
%{_bindir}/neutron-server
%{_bindir}/neutron-usage-audit
%{_unitdir}/neutron-dhcp-agent.service
%{_unitdir}/neutron-l3-agent.service
%{_unitdir}/neutron-metadata-agent.service
%{_unitdir}/neutron-server.service
%{_unitdir}/neutron-netns-cleanup.service
%{_unitdir}/neutron-ovs-cleanup.service
%{_unitdir}/neutron-linuxbridge-cleanup.service
%attr(-, root, %{service}) %{_datadir}/%{service}/api-paste.ini
%dir %{_datadir}/%{service}/l3_agent
%dir %{_datadir}/%{service}/server
%{_datadir}/%{service}/l3_agent/*.conf
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/dhcp_agent.ini
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/l3_agent.ini
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/metadata_agent.ini
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/policy.json
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-dhcp-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-l3-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-metadata-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-server
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-netns-cleanup
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-ovs-cleanup
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-linuxbridge-cleanup


%files -n python-%{service}-tests
%license LICENSE
%{python2_sitelib}/%{service}/tests

%files -n python-%{service}
%license LICENSE
%{python2_sitelib}/%{service}
%{python2_sitelib}/%{service}-*.egg-info
%exclude %{python2_sitelib}/%{service}/tests


%files common -f %{service}.lang
%license LICENSE
%doc README.rst
# though this script is not exactly needed on all nodes but for ovs and
# linuxbridge agents only, it's probably good enough to put it here
%{_bindir}/neutron-enable-bridge-firewall.sh
%{_bindir}/neutron-rootwrap
%{_bindir}/neutron-rootwrap-daemon
%{_bindir}/neutron-rootwrap-xen-dom0
%dir %{_sysconfdir}/%{service}
%{_sysconfdir}/%{service}/conf.d/README
%dir %{_sysconfdir}/%{service}/conf.d
%dir %{_sysconfdir}/%{service}/conf.d/common
%dir %{_sysconfdir}/%{service}/plugins
%attr(-, root, %{service}) %{_datadir}/%{service}/%{service}-dist.conf
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/%{service}.conf
%config(noreplace) %{_sysconfdir}/%{service}/rootwrap.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/*
%{_sysconfdir}/sudoers.d/%{service}
%dir %attr(0755, %{service}, %{service}) %{_sharedstatedir}/%{service}
%dir %attr(0750, %{service}, %{service}) %{_localstatedir}/log/%{service}
%dir %{_datarootdir}/%{service}
%dir %{_datarootdir}/%{service}/rootwrap
%{_datarootdir}/%{service}/rootwrap/*


%files linuxbridge
%license LICENSE
%{_bindir}/neutron-linuxbridge-agent
%{_unitdir}/neutron-linuxbridge-agent.service
%{_datarootdir}/%{service}/rootwrap/linuxbridge-plugin.filters
%dir %{_sysconfdir}/%{service}/plugins/ml2
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/linuxbridge_agent.ini
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-linuxbridge-agent
%{_sysctldir}/99-neutron-linuxbridge-agent.conf
%{_sysconfdir}/sysconfig/modules/neutron-linuxbridge-agent.modules


%files macvtap-agent
%license LICENSE
%{_bindir}/neutron-macvtap-agent
%{_unitdir}/neutron-macvtap-agent.service
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-macvtap-agent


%files ml2
%license LICENSE
%doc %{service}/plugins/ml2/README
%dir %{_sysconfdir}/%{service}/plugins/ml2
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/*.ini
%exclude %{_sysconfdir}/%{service}/plugins/ml2/linuxbridge_agent.ini
%exclude %{_sysconfdir}/%{service}/plugins/ml2/openvswitch_agent.ini


%files openvswitch
%license LICENSE
%{_bindir}/neutron-openvswitch-agent
%{_unitdir}/neutron-openvswitch-agent.service
%{_unitdir}/neutron-destroy-patch-ports.service
%{_datarootdir}/%{service}/rootwrap/openvswitch-plugin.filters
%dir %{_sysconfdir}/%{service}/plugins/ml2
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/openvswitch_agent.ini
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-openvswitch-agent
%{_sysctldir}/99-neutron-openvswitch-agent.conf
%{_sysconfdir}/sysconfig/modules/neutron-openvswitch-agent.modules


%files metering-agent
%license LICENSE
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/metering_agent.ini
%{_unitdir}/neutron-metering-agent.service
%{_bindir}/neutron-metering-agent
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-metering-agent


%files rpc-server
%license LICENSE
%{_bindir}/neutron-rpc-server
%{_unitdir}/neutron-rpc-server.service
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-rpc-server


%files sriov-nic-agent
%license LICENSE
%{_unitdir}/neutron-sriov-nic-agent.service
%{_bindir}/neutron-sriov-nic-agent
%config(noreplace) %attr(0640, root, %{service}) %{_sysconfdir}/%{service}/plugins/ml2/sriov_agent.ini
%dir %{_sysconfdir}/%{service}/conf.d/%{service}-sriov-nic-agent


%changelog
* Mon Mar 08 2021 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-42
- Fix wrong packet_type set for IPv6 GRE tunnels in OVS (rhbz#1773732)

* Thu Feb 25 2021 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-41
- [OVS FW] Clean conntrack entries with mark == CT_MARK_INVALID (rhbz#1904463)

* Mon Feb 22 2021 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-40
- Don't try to create default SG when security groups are disabled (rhbz#1926145)

* Mon Feb 15 2021 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-39
- Fix update of trunk subports during live migration (rhbz#1909930)

* Fri Feb 05 2021 Austin Hyder <ahyder@redhat.com> 1:12.1.1-38
- Fix migration from the HA to non-HA routers
- Revert "[Security] fix allowed-address-pair 0.0.0.0/0 issue"
- Local mac direct flow for non-openflow firewall
- Drop invalid rootwrap filters
- Replace ctype.CDLL by ctypes.PyDLL in linux.ip_lib
- Load the glibc library only once for Pyroute2
- Don't raise FileNotFoundError during disabling keepalived
- Support gateway which is not in subnet CIDR in ha_router
- "ping"/"ping6" command support in rootwrap filters
- ovs firewall: fix mac learning on the ingress rule table when ovs offload enabled
- windows: fix terminating processes
- Import "oslo_config.cfg" before "eventlet"
- Ensure fip ip rules deleted when fip removed
- [OvS] Handle re_added multi ports
- [GRE] Add possibility to create GRE tunnels over IPv6 (rhbz#1773732)
- Fix calling of add_tunnel_port method from sanity checks module (rhbz#1773732)
- neutron-server api worker process should be named to their role (rhbz#1887455)
- Do not fail deleting namespace if it does not exist
- Pass context in l3 flavor notifications
- Pass context in disassociate_floatingip notification
- Fix deletion of subnet_id from pd_subnets
- Fix unnecessary security_groups_member_updated notification
- Use dict .get() to avoid a KeyError in the segment plugin
- Not remove the running router when MQ is unreachable
- Fix "test_keepalived_configuration" functional test (rhbz#1869355)
- Do not send a GARP when a new floating IP is added (rhbz#1869355)
- Add "vrrp_garp_master_delay" and "vrrp_garp_master_repeat" parameters (rhbz#1869355)

* Tue Oct 06 2020 Miguel Garcia <mgarciac@redhat.com> 1:12.1.1-35.1
- Fix get_ports db plugin method (rhbz#1881136)

* Thu Aug 20 2020 Miguel Garcia <mgarciac@redhat.com> 1:12.1.1-35
- [Security] fix allowed-address-pair 0.0.0.0/0 issue
- Fix Traceback when running neutron-ipset-cleanup tool
- Fix validation of IPv6 subnets with external RAs
- [stable only] Configure logging in keepalived_state_change
- Don't add arp responder for non tunnel network port
- Make _ensure_default_security_group method atomic
- Update the processing of assigned addresses when assigning addresses
- [EM releases] Move non-voting jobs to the experimental queue
- [OVS] Make QoS OVS agent deletion operations more resilient
- Add "igmp_snooping_enable" config option for OVS agent
- Fix queens gates, multiple fixes
- Only notify nova of port status changes if configured
- Report L3 extensions enabled in the L3 agent's config
- Improve VLAN allocations synchronization

* Wed Aug 05 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-34
- Don't check if any bridges were recrected when OVS was restarted (rhbz#1840225)

* Tue Aug 04 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:12.1.1-33
- [OVS][FW] Remote SG IDs left behind when a SG is removed (rhbz#1835028)

* Tue Jul 21 2020 Bernard Cafarelli <bcafarel@redhat.com> 1:12.1.1-32
- Set process name for agents (rhbz#1836852)

* Mon Jul 20 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:12.1.1-31
- Ensure drop flows on br-int at agent startup for DVR too (rhbz#1847835)

* Mon Jul 13 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:12.1.1-30
- [DVR] Related routers should be included if are requested (rhbz#1847422)

* Sat Jul 11 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-29
- Add config option ``http_retries`` (rhbz#1845802)

* Thu Jul 02 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-28
- Improve log message when port losts its vlan tag (rhbz#1852519)

* Wed Jul 01 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-27
- Catch OVSFWTagNotFound in update_port_filter (rhbz#1852519)
- Avoid empty "vsctl" transactions (rhbz#1851980)

* Tue Jun 30 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-26
- Do not block connection between br-int and br-phys on startup (rhbz#1847835)

* Tue Jun 23 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:12.1.1-25
- Make QoS OVS agent deletion operations more resiliant (rhbz#1848605)

* Tue Jun 23 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-24
- Router synch shouldn't return unrelated routers (rhbz#1833259)
- Adding LOG statements to debug 1838449 (rhbz#1833259)

* Tue Jun 09 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-23
- Allow usage of legacy 3rd-party interface drivers (rhbz#1783347)

* Mon Jun 08 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:12.1.1-22
- Kill parent process of "ip monitor" command (rhbz#1819771)

* Mon Jun 08 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-21
- [DVR] Reconfigure re-created physical bridges for dvr routers (rhbz#1840225)
- Ensure that stale flows are cleaned from phys_bridges (rhbz#1840225)
- Do not link up HA router gateway in backup node (rhbz#1783347)

* Tue Jun 02 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-20
- Unnecessary routers should not be created (rhbz#1841827)

* Mon Jun 01 2020 Nate Johnston <iam@natejohnston.info> 1:12.1.1-19
- Dynamically increase l3 router process queue green pool size (rhbz#1835202)

* Wed May 06 2020 Miguel Garcia <mgarciac@redhat.com> 1:12.1.1-18
- Delay HA router transition from "backup" to "master"
- Don't raise error when removing not existing IP address
- Change ovs-agent iteration log level to INFO
- Refactor the L3 agent batch notifier
- Filter by owner SGs when retrieving the SG rules
- Check dnsmasq process is active when spawned
- Handle ports assigned to routers without routerports
- Increase waiting time for network rescheduling
- Remove Floating IP DNS record upon associated port deletion
- Add accepted egress direct flow
- Add VLAN type conntrack direct flow
- Ensure that default SG exists during list of SG rules API call
- Remove extra header fields in proxied metadata requests
- Improve "OVSFirewallDriver.process_trusted_ports"
- ovs agent: signal to plugin if tunnel refresh needed
- Ensure that fullstack job is run with python 2.7
- Check SG members instead of ports to skip flow update
- dhcp-agent: equalize port create_low/update/delete priority
- Always set ovs bridge name in vif:binding-details
- [OVS] Handle added/removed ports in the same polling iteration
- Define orm relationships after db classes
- Allow to kill keepalived state change monitor process
- Switch create/delete interfaces to pyroute2 (rhbz#1783347)
- Switch ip addr add/del/flush commands to use pyroute2 (rhbz#1783347)

* Thu Apr 23 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-17
- Fix is_port_bound function in l3_dvr_db module (rhbz#1818695)

* Tue Apr 14 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-16
- Support iproute2 4.15 in l3_tc_lib (rhbz#1823601)

* Fri Apr 10 2020 Bernard Cafarelli <bcafarel@redhat.com> 1:12.1.1-15
- Wait before deleting trunk bridges for DPDK vhu (rhbz#1810451)
- Add trunk subports to be one of dvr serviced device owners (rhbz#1819055)
- Do not initialize snat-ns twice (rhbz#1783347)
- [DVR] Don't populate unbound ports in router's ARP cache (rhbz#1818695)
- Remove sleep command when retrieving OVS dp (rhbz#1820379)
- Optimize DVR related port DB query (rhbz#1818695)
- DVR: Ignore DHCP port during DVR host query (rhbz#1818695)

* Wed Apr 01 2020 Nate Johnston <iam@natejohnston.info> 1:12.1.1-14
- Add bulk IP address assignment to ipam driver (rhbz#1815590)

* Fri Mar 27 2020 Brian Haley <bhaley@redhat.com> 1:12.1.1-13
- Revert "Switch to use cast method in dhcp_ready_on_ports method" (rhbz#1813640)
- Prioritize port create and update ready messages (rhbz#1813640)

* Fri Mar 27 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:12.1.1-12
- During post live-migration do not disable destination host port (rhbz#1815012)

* Fri Mar 13 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:12.1.1-11
- Use threading for pinging the floating IP (rhbz#1812882)

* Mon Mar 02 2020 Bernard Cafarelli <bcafarel@redhat.com> 1:12.1.1-10
- Re-use existing ProcessLauncher from wsgi in RPC workers (rhbz#1792820)

* Thu Feb 27 2020 Nate Johnston <iam@natejohnston.info> 1:12.1.1-9
- Change process name of neutron-server to match worker role (rhbz#1808025)

* Mon Feb 24 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-8
- Mock check if ipv6 is enabled in L3 agent unit tests (rhbz#1805277)

* Thu Feb 20 2020 Nate Johnston <iam@natejohnston.info> 1:12.1.1-7
- Ensure driver error preventing trunk port deletion is logged (rhbz#1779138)

* Mon Feb 10 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-6
- Fix listing of security group rules by regular user (rhbz#1803525)

* Mon Feb 10 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.1-5
- List SG rules which belongs to tenant's SG (rhbz#1709610)

* Fri Jan 31 2020 Nate Johnston <iam@natejohnston.info> 1:12.1.1-4
- Add retries to update trunk port (rhbz#1736854)

* Wed Jan 29 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:12.1.1-3
- Do not unbind a port during pre-live migration (rhbz#1791589)

* Tue Jan 28 2020 Miguel Garcia <mgarciac@redhat.com> 1:12.1.1-2
- Set DB retry for quota_enforcement pecan_wsgi hook
- [OVS FW] Clean port rules if port not found in ovsdb
- Switch to use cast method in dhcp_ready_on_ports method
- Handle OVSFWPortNotFound and OVSFWTagNotFound in ovs firewall
- Log OVS firewall conjunction creation

* Tue Jan 28 2020 Miguel Garcia <mgarciac@redhat.com> 1:12.1.1-1
- Update to 12.1.1

* Tue Jan 28 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:12.1.0-12
- Change provider network segmentation ID in OVS agent (rhbz#1791869)
- Allow provider net attr in update if no change (rhbz#1791869)

* Mon Jan 27 2020 Nate Johnston <iam@natejohnston.info> 1:12.1.0-11
- OVS flows for custom ethertypes must be on EGRESS (rhbz#1718469)
- Decouple local VLAN internal management and OVS enforcement (rhbz#1791869)
- Change provider network segmentation ID (rhbz#1791869)

* Thu Jan 16 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.0-10
- [L3] Switch order of processing added and removed router ports (rhbz#1779654)

* Thu Jan 16 2020 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.0-9
- don't clear skb mark when ovs is hw-offload enabled (rhbz#1780287)

* Mon Jan 13 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:12.1.0-8
- Update patches

* Fri Jan 03 2020 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:12.1.0-7
- Force "network_id" in "subnet" DB registers (rhbz#1783076)

* Tue Dec 10 2019 Nate Johnston <nate.johnston@redhat.com> 1:12.1.0-6
- Add more condition to check sg member exist (rhbz#1688323)

* Wed Nov 27 2019 Flavio Fernandes <flaviof@redhat.com> 1:12.1.0-5
- Run revision bump operations en masse (rhbz#1776950)

* Tue Nov 19 2019 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:12.1.0-4
- Increase timeout when waiting for dnsmasq enablement (rhbz#1762849)

* Tue Nov 05 2019 Slawek Kaplonski <skaplons@redhat.com> 1:12.1.0-3
- Fix mismatch of tags in dnsmasq options (rhbz#1759745)
- fixed_configured=True when Add/Remove port IPs (rhbz#1760122)

* Wed Oct 09 2019 Bernard Cafarelli <bcafarel@redhat.com> 1:12.1.0-2
- Delay floating IP assignation in DVR router during migration (rhbz#1749822)

* Wed Oct 02 2019 Steve Linabery <slinaber@redhat.com> 1:12.1.0-1
- Update to 12.1.0
- Fix creation of vlan network with segmentation_id set to 0
- Add info log about ready DHCP config for ports
- Check the namespace is ready in test_mtu_update tests
- Increase timeouts for OVSDB in functional tests
- Use created subnet in port generator in "test_port_ip_update_revises"
- Increase TestDhcpAgentHA.agent_down_time to 30 seconds
- Remove experimental openSUSE 42.3 job
- Populate binding levels when concurrent ops fail
- Clear skb mark on encapsulating packets
- Stop OVS agent before starting it again
- Make sure the port still in port map when prepare_port_filter
- [DVR] Add lock during creation of FIP agent gateway port
- Check for agent restarted after checking for DVR port
- fix update port bug
- Don't crash ovs agent during reconfigure of phys bridges
- Filter placement API endpoint by type too
- Use --bind-dynamic with dnsmasq instead of --bind-interfaces
- Yield control to other greenthreads while processing trusted ports
- Turn CIDR in query filter into proper subnet

* Wed Sep 25 2019 Slawek Kaplonski <skaplons@redhat.com> 1:12.0.6-13
- Treat networks shared by RBAC in same way as shared with all tenants (rhbz#1753118)
- Increase number of retries in _process_trunk_subport_bindings (rhbz#1736854)

* Fri Aug 23 2019 Bernard Cafarelli <bcafarel@redhat.com> 1:12.0.6-12
- Fix sort issue in test_dhcp_agent_scheduler.test_filter_bindings (rhbz#1740092)

* Tue Aug 20 2019 Bernard Cafarelli <bcafarel@redhat.com> 1:12.0.6-11
- Initialize phys bridges before setup_rpc (rhbz#1722578)

* Wed Aug 14 2019 Slawek Kaplonski <skaplons@redhat.com> 1:12.0.6-10
- Retry trunk status updates failing with StaleDataError (rhbz#1736854)

* Fri Aug 02 2019 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:12.0.6-9
- Change VF status from "enable" to "auto". (rhbz#1656978)

* Wed Jul 31 2019 Bernard Cafarelli <bcafarel@redhat.com> 1:12.0.6-8
- Make OVS controller inactivity_probe configurable (rhbz#1721346)

* Wed Jul 17 2019 Slawek Kaplonski <skaplons@redhat.com> 1:12.0.6-7
- Show all SG rules belong to SG in group's details (rhbz#1709610)

* Tue Jul 16 2019 Brian Haley <bhaley@redhat.com> 1:12.0.6-6
- Limit max ports per rpc for dhcp_ready_on_ports() (rhbz#1723935)

* Mon Jul 08 2019 Nate Johnston <nate.johnston@redhat.com> 1:12.0.6-5
- Add custom ethertype processing (rhbz#1718469)

* Fri Jun 21 2019 Slawek Kaplonski <skaplons@redhat.com> 1:12.0.6-4
- [DVR] Block ARP to dvr router's port instead of subnet's gateway (rhbz#1714422)

* Fri Jun 21 2019 Bernard Cafarelli <bcafarel@redhat.com> 1:12.0.6-3
- Use list instead of six.viewkeys to avoid py2 to py3 problems (rhbz#1722422)

* Thu Jun 13 2019 Jakub Libosvar <jlibosva@redhat.com> - 1:12.0.6-2
- tests: Remove python-oslo-db-tests dependency

* Tue Jun 04 2019 Steve Linabery <slinaber@redhat.com> 1:12.0.6-1
- Update to 12.0.6
- [DHCP] Don't resync network if same port is alredy in cache
- Remove rootwrap configuration from neutron-keepalived-state-change
- Use six.viewkeys instead of dict.keys to avoid py2 to py3 problems
- Ensure dvr ha router gateway port binding host
- Async notify neutron-server for HA states
- Keep HA ports info for HA router during entire lifecycle
- Get ports query: extract limit and use it only at the end.
- Use dynamic lazy mode for fetching security group rules
- objects: avoid deepcopying models in test_db_obj
- Give some HA router case specific resources
- Move subnet postcommit out of transaction for bulk create
- Fix attribute mismatch in router provider update
- Check master/backup router status in DVR functional tests
- Set HA failover bridges veth pair devices UP
- neutron.conf needs lock_path set for router to operate This change is adding required configuration in neutron.conf to set the lock_path parameter, which was missing in compute-install-ubuntu.rst
- Do not call update_device_list in large sets
- Choose random value for HA routes' vr_id
- DVR: Correctly change MTU in fip namespace
- Handle DBConnectionError in skip_if_timeout decorator
- Improve port dhcp Provisioning
- Rename router processing queue code to be more generic
- Fix regression with SG read API with empty ruleset
- Change ovs version we use in fullstack tests
- Change default local ovs connection timeout

* Thu May 30 2019 Nate Johnston <nate.johnston@redhat.com> 1:12.0.5-16
- Allow first address in an IPv6 subnet as valid unicast (rhbz#1687457)

* Fri May 17 2019 Slawek Kaplonski <skaplons@redhat.com> 1:12.0.5-15
- Fix handling of network:shared field in policy module (rhbz#1657546)
- Fix creating policy rules from subattributes. (rhbz#1657546)
- Add missing policy actions to policy.json file (rhbz#1657546)

* Tue May 14 2019 Brian Haley <bhaley@redhat.com> 1:12.0.5-14
- Revert iptables TCP checksum-fill code (rhbz#1701879)

* Fri Apr 12 2019 Brian Haley <bhaley@redhat.com> 1:12.0.5-13
- More accurate agent restart state transfer (rhbz#1692156)

* Thu Apr 11 2019 Nate Johnston <nate.johnston@redhat.com> 1:12.0.5-12
- Don't pass None arg to neutron-keepalived-state-change (rhbz#1692156)
- Add enforcer logic for neutron policy (rhbz#1678771) (rhbz#1680574)

* Fri Apr 05 2019 Jon Schlueter <jschluet@redhat.com> 1:12.0.5-11
- update from stable/queens (rhbz#1696792)
- Enable ipv6_forwarding in HA router's namespace
- Set initial ha router state in neutron-keepalived-state-change
- Spawn metadata proxy on dvr ha standby routers
- DVR edge router: avoid accidental centralized floating IP remove
- Add new test decorator skip_if_timeout
- Fix notification about arp entries for dvr routers
- Fix port update deferred IP allocation with host_id + new MAC
- Switch isolated metadata proxy to bind to 169.254.169.254
- Ensure dnsmasq is down before enabling it in restart method
- Add lock_path in installation guide
- Update neutron files for new over-indentation hacking rule (E117)
- Fix performance regression adding rules to security groups
- Always fill UDP checksums in DHCPv6 replies
- Secure dnsmasq process against external abuse
- Remove IPv6 addresses in dnsmasq leases file
- Clear residual qos rules after l2-agent restarts.
- protect DHCP agent cache out of sync
- Check port VNIC type when associating a floating IP (rhbz#1629465)

* Fri Apr 05 2019 Bernard Cafarelli <bcafarel@redhat.com> 1:12.0.5-10
- Fix KeyError in OVS firewall (rhbz#1695451)

* Wed Apr 03 2019 Nate Johnston <nate.johnston@redhat.com> 1:12.0.5-9
- Improve invalid port ranges error message (rhbz#1676785)

* Fri Mar 29 2019 Bernard Cafarelli <bcafarel@redhat.com> 1:12.0.5-8
- When converting sg rules to iptables, do not emit dport if not supported (rhbz#1691121)

* Mon Mar 18 2019 Brian Haley <bhaley@redhat.com> 1:12.0.5-7
- Do not release DHCP lease when no client ID is set on port (rhbz#1685893)

* Thu Mar 07 2019 Slawek Kaplonski <skaplons@redhat.com> 1:12.0.5-6
- Fix update of ports cache in router_info class (rhbz#1630167)

* Tue Mar 05 2019 Rodolfo Alonso Hernandez <ralonsoh@redhat.com> 1:12.0.5-5
- Change duplicate OVS bridge datapath-ids (rhbz#1654840)

* Mon Jan 28 2019 Steve Linabery <slinaber@redhat.com> 1:12.0.5-4
- Sync spec to queens-rdo
- [DVR] Allow multiple subnets per external network
- Enable 'all' IPv6 forwarding knob correctly
- Don't modify global variables in unit tests
- Add kill_timeout to AsyncProcess
- Do state report after setting start_flag on OVS restart
- Block port update from unbound DHCP agent
- Fix the bug about DHCP port whose network has multiple subnets.
- Force all fdb entries update after ovs-vswitchd restart
- Reinitialize ovs firewall after ovs-vswitchd restart
- Get centralized FIP only on router's snat host
- Fix neutron-openvswitch-agent Windows support
- Update docs for disabling DNS server announcement
- DevStack: OVS: Only install kernel-* packages when needed
- Include all rootwrap filters when building wheels
- DVR: Centralized FloatingIPs are not cleared after migration.
- Fix connection between 2 dvr routers
- Wait to ipv6 forwarding be really changed by L3 agent
- Add missing step for ovs deploy guides
- Pass network's dns_domain to dnsmasq conf
- Revert "Adjust whitespace in setup.cfg"

* Wed Dec 19 2018 Slawek Kaplonski <skaplons@redhat.com> 1:12.0.5-3
- Do not delete trunk bridges if service port attached (rhbz#1655177)

* Mon Nov 26 2018 Jon Schlueter <jschluet@redhat.com> 1:12.0.5-2
- iptables-restore wait period cannot be zero
- Make port binding attempt after agent is revived (rhbz#1630420)
- Update to 12.0.5 (rhbz#1653432)

* Wed Oct 17 2018 Jon Schlueter <jschluet@redhat.com> 1:12.0.4-2
- Update to 12.0.4 (rhbz#1639971)
- Do not install centralized FIP if HA port is down
- Don't uninstall flow tables in setup_dvr_flows_on_integ_br
- Parse dhcp leases file in a more robust way
- ovsdb monitor: do not die on ovsdb-client stderr output
- l2 pop: check for more than 1 first active port on a node
- Revert "DVR: Inter Tenant Traffic between networks not possible with shared net"
- Revert "DVR: Add error handling for get_network_info_for_id rpc call"
- Remove fdb entries for ha router interfaces when going DOWN (rhbz#1622495)
- Use oslo_db.sqlalchemy.test_fixtures (rhbz#1546809)

* Tue Sep 11 2018 Jason Joyce <jjoyce@redhat.com> 1:12.0.3-5
- Disallow router interface out of subnet IP range (rhbz#1608089)

* Tue Aug 28 2018 Jon Schlueter <jschluet@redhat.com> 1:12.0.3-4
- Remove messaging section from neutron-dist.conf (rhbz#1601593)

* Thu Aug 23 2018 Bernard Cafarelli <bcafarel@redhat.com> 1:12.0.3-3
- [QoS] Clear rate limits when default null values are used (rhbz#1610792)
- cap bandit in test-requirements.txt (rhbz#1619637)

* Wed Jul 18 2018 Jon Schlueter <jschluet@redhat.com> 1:12.0.3-2
- [Fullstack] HA L3 agent restart only standby agents
- Mark unit test test_get_objects_queries_constant as unstable
- DVR: Self recover from the loss of 'fg' ports in FIP Namespace
- DVR: FIP gateway port is tagged as DEAD port by OVS with external-bridge
- Fix an attribute error on listing AZs with filters
- Use rally 0.12.1 release for stable/queens branch.
- Mark test_ha_router_restart_agents_no_packet_lost as unstable
- Revert "Ensure _get_changed_synthetic_fields() return updatable fields"
- DVR: FloatingIP create throws an error if no l3 agent
- Windows: fix exec calls
- Don't set administratively disabled ports as ACTIVE
- Add/rm centralized fips for DVR+HA from standby node
- [Fullstack] Wait for SG to be applied by L2 agent
- ovs: removed sinkhole RPC target for old topics
- Revert "DVR: Fix allowed_address_pair IP, ARP table update by neutron agent"
- Fix DVR scheduling checks wrong profile for host
- Use neutron-tempest-plugin-jobs-queens job template
- [Fullstack] Add block test until IPs will be really configured
- Ensure _get_changed_synthetic_fields() return updatable fields
- Adds egress and ingress forward rules for trusted ports
- Update to 12.0.3 (rhbz#1603033)

* Thu Jul 05 2018 Jon Schlueter <jschluet@redhat.com> 1:12.0.2-2
- Update to 12.0.2

* Thu Jun 28 2018 Slawek Kaplonski <skaplons@redhat.com> 1:12.0.2-0.20180421011364.0ec54fd
- [OVS] Add mac-table-size to be set on each ovs bridge (rhbz#1591206)

* Thu Jun 28 2018 Slawek Kaplonski <skaplons@redhat.com> 1:12.0.2-0.20180421011363.0ec54fd
- Configure privsep helper in neutron-netns-cleanup (rhbz#1595177)

* Wed Jun 13 2018 Slawek Kaplonski <skaplons@redhat.com> 1:12.0.2-0.20180421011362.0ec54fd
- Monitor phys_bridges to reconfigured it if created again (rhbz#1576286)

* Tue Jun 05 2018 Brian Haley <bhaley@redhat.com> 1:12.0.2-0.20180421011361.0ec54fd
- Retry dhcp_release on failures (rhbz#1574212)

* Fri Jun 01 2018 Bernard Cafarelli <bcafarel@redhat.com> 1:12.0.2-0.20180421011360.0ec54fd
- Disable IPv6 forwarding by default on HA routers (rhbz#1578765)

* Tue May 15 2018 Slawek Kaplonski <skaplons@redhat.com> 1:12.0.2-0.20180421011359.0ec54fd
- ovs-fw: Apply openflow rules immediately during update (rhbz#1574500)

